package com.aucma.base.mapper;

import java.util.List;
import com.aucma.base.domain.OrderBomInfo;
import org.apache.ibatis.annotations.Param;

/**
 * 产品BOMMapper接口
 * 
 * @author Yinq
 * @date 2023-09-28
 */
public interface OrderBomInfoMapper 
{
    /**
     * 查询产品BOM
     * 
     * @param objId 产品BOM主键
     * @return 产品BOM
     */
    public OrderBomInfo selectOrderBomInfoByObjId(Long objId);

    /**
     * 查询产品BOM列表
     * 
     * @param orderBomInfo 产品BOM
     * @return 产品BOM集合
     */
    public List<OrderBomInfo> selectOrderBomInfoList(OrderBomInfo orderBomInfo);

    /**
     * 查询成品产品BOM列表
     *
     * @param orderBomInfo 产品BOM
     * @return 产品BOM集合
     */
    public List<OrderBomInfo> selectFinishedProductBomInfoList(OrderBomInfo orderBomInfo);

    /**
     * 新增产品BOM
     * 
     * @param orderBomInfo 产品BOM
     * @return 结果
     */
    public int insertOrderBomInfo(OrderBomInfo orderBomInfo);

    /**
     * 修改产品BOM
     * 
     * @param orderBomInfo 产品BOM
     * @return 结果
     */
    public int updateOrderBomInfo(OrderBomInfo orderBomInfo);

    /**
     * 删除产品BOM
     * 
     * @param objId 产品BOM主键
     * @return 结果
     */
    public int deleteOrderBomInfoByObjId(Long objId);

    /**
     * 批量删除产品BOM
     * 
     * @param objIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteOrderBomInfoByObjIds(Long[] objIds);



    /**
     * 根据ID查询所有子Bom
     * @param materialCode
     * @return
     */
    List<OrderBomInfo> selectChildrenBomById(@Param("materialCode") String materialCode);

    /**
     * 修改子元素关系
     *
     * @param children 子元素
     * @return 结果
     */
    void updateBomChildren(@Param("depts") List<OrderBomInfo> children);


    /**
     * 根据BOM编号查询产品BOM
     *
     * @param materialCode 生产BOM主键
     * @return 产品BOM
     */
    public OrderBomInfo selectOrderBomInfoByMaterialCode(@Param("materialCode") String materialCode);
}
